#include "config.h"

#include "util.h"
#include "timer.h"
#include "eventmanager.h"
#include "signalmanager.h"
#include "fdutils.h"
#include "native_helpers.h"
#include <signal.h>
#include <time.h>
#include <sys/time.h>
#include <stdlib.h>
#include <errno.h>
#include <pthread.h>

#if HAVE_PTHREAD

static jlong period;

static void *timerThread(void *arg) {
    struct timespec req;
    for (;;) {
	req.tv_sec=period/1000000000;
	req.tv_nsec=period%1000000000;
	nanosleep(&req,NULL);
	SIGNAL_EVENT_FROM_THREAD();
    }
}

jint initNanosleepTimer(jlong period_) {
    pthread_t t;
    period=period_;
    pthread_create(&t,NULL,timerThread,NULL);
    return 1;
}

#else

jint initNanosleepTimer(jlong period) { return 0; }

#endif
