package ovm.core.services.memory;

import ovm.core.domain.Blueprint;
import ovm.core.domain.Oop;
import ovm.core.execution.NativeConstants;

public abstract class ExtentWalker {
    static public abstract class Scanner extends ExtentWalker {
	protected abstract void walk(Oop object, Blueprint type);

	public VM_Address walkRet(VM_Address start, VM_Address end) {
	    while (start.uLT(end)) {
		Oop o = start.asOop();
		Blueprint bp = o.getBlueprint();
		if (bp == null) {
		    // FIXME: VM_Word vs. int. Changing it wakes up j2c bugs.
		    int next = start.asInt() + NativeConstants.PAGE_SIZE;
		    start = VM_Address.fromInt(next & -NativeConstants.PAGE_SIZE);
		} else {
		    start = start.add(bp.getVariableSize(o));
		    walk(o, bp);
		}
	    }
	    return start;
	}
	
	public void walk(VM_Address start, VM_Address end) {
	    while (start.uLT(end)) {
		Oop o = start.asOop();
		Blueprint bp = o.getBlueprint();
		if (bp == null) {
		    // FIXME: VM_Word vs. int. Changing it wakes up j2c bugs.
		    int next = start.asInt() + NativeConstants.PAGE_SIZE;
		    start = VM_Address.fromInt(next & -NativeConstants.PAGE_SIZE);
		} else {
		    start = start.add(bp.getVariableSize(o));
		    walk(o, bp);
		}
	    }
	}
	
    }

    public abstract void walk(VM_Address start, VM_Address end);
    public abstract VM_Address walkRet(VM_Address start, VM_Address end);
}
