/**
 * ConditionQueue.java
 *
 * $Header: /p/sss/cvs/OpenVM/src/ovm/services/monitors/ConditionQueue.java,v 1.6 2004/02/20 08:48:46 jthomas Exp $
 *
 */
package ovm.services.monitors;


/**
 * Defines the waiting side of the abstract notion of a &quot;condition&quot; 
 * as used with the
 * monitors of Hoare & Brinch-Hansen and those used in languages like
 * Modula-3 and Java. This marker interface provides no semantic details
 * as they vary between monitor types. More specific condition queue types will
 * provide specific semantics.
 * <p>We split the waiting and signalling aspects of conditions into two
 * interfaces to allow easy customisation of the wait semantics without
 * needing to redefine the signalling semantics each time.
 *
 * @see Monitor
 * @see ConditionQueueSignaller
 * @see AbortableConditionQueue
 * @see TimedConditionQueue
 * @see TimedAbortableConditionQueue
 * 
 * @author David Holmes
 *
 */
public interface ConditionQueue {
}





