package s3.services.simplejit.powerpc;

/**
 * @author Hiroshi Yamauchi
 */
public interface PPCConstants {
    
    /* bits in control register */
    public static final int CR0 = 0;
    public static final int CR0_LT = 0;
    public static final int CR0_GT = 1;
    public static final int CR0_EQ = 2;
    public static final int CR0_SO = 3;
    public static final int CR7 = 7;
    public static final int CR7_LT = 28;
    public static final int CR7_GT = 29;
    public static final int CR7_EQ = 30;
    public static final int CR7_SO_OR_FU = 31;
    public static final int BO_TRUE = 12;
    public static final int BO_FALSE = 4;
    
    /* General registers */
    public static final int R0 = 0;
    public static final int R1 = 1;
    public static final int R2 = 2;
    public static final int R3 = 3;
    public static final int R4 = 4;
    public static final int R5 = 5;
    public static final int R6 = 6;
    public static final int R7 = 7;
    public static final int R8 = 8;
    public static final int R9 = 9;
    public static final int R10 = 10;
    public static final int R11 = 11;
    public static final int R12 = 12;
    public static final int R13 = 13;
    public static final int R14 = 14;
    public static final int R15 = 15;
    public static final int R16 = 16;
    public static final int R17 = 17;
    public static final int R18 = 18;
    public static final int R19 = 19;
    public static final int R20 = 20;
    public static final int R21 = 21;
    public static final int R22 = 22;
    public static final int R23 = 23;
    public static final int R24 = 24;
    public static final int R25 = 25;
    public static final int R26 = 26;
    public static final int R27 = 27;
    public static final int R28 = 28;
    public static final int R29 = 29;
    public static final int R30 = 30;
    public static final int R31 = 31;
    
    public static final int SP = R1;
    
    /* Floating point registers */
    public static final int F0 = 0;
    public static final int F1 = 1;
    public static final int F2 = 2;
    public static final int F3 = 3;
    public static final int F4 = 4;
    public static final int F5 = 5;
    public static final int F6 = 6;
    public static final int F7 = 7;
    public static final int F8 = 8;
    public static final int F9 = 9;
    public static final int F10 = 10;
    public static final int F11 = 11;
    public static final int F12 = 12;
    public static final int F13 = 13;
    public static final int F14 = 14;
    public static final int F15 = 15;
    public static final int F16 = 16;
    public static final int F17 = 17;
    public static final int F18 = 18;
    public static final int F19 = 19;
    public static final int F20 = 20;
    public static final int F21 = 21;
    public static final int F22 = 22;
    public static final int F23 = 23;
    public static final int F24 = 24;
    public static final int F25 = 25;
    public static final int F26 = 26;
    public static final int F27 = 27;
    public static final int F28 = 28;
    public static final int F29 = 29;
    public static final int F30 = 30;
    public static final int F31 = 31;
}