package javax.realtime;

/** 
 * {@link PhysicalMemoryManager} can only accomodate one filter object for
 * each type of memory.  It throws this exception if an attempt is made to 
 * register more than one filter for a type of memory.
 *
 * @spec RTSJ 1.0.1
 */
public class DuplicateFilterException extends Exception {

    /**
     * A constructor for <tt>DuplicateFilterException</tt>
     */
    public DuplicateFilterException(){ }

    /**
     * A descriptive constructor for <tt>DuplicateFilterException</tt>
     * @param  description   Description of the exception
     */
    public DuplicateFilterException(String description){
        super(description);
    }
}
