package javax.realtime;

/**
 * This exception is thrown when the {@link PhysicalMemoryManager} is given
 * conflicting specifications for memory. The conflict can be between types 
 * in an array of memory type specifiers, or between the specifiers and a 
 * specified base address.
 *
 * @since 1.0.1 Changed to an unchecked exception.
 *
 * @spec RTSJ 1.0.1
 */

public class MemoryTypeConflictException extends RuntimeException{

    /**
     * A constructor for <tt>MemoryTypeConflictException</tt>
     */
    public MemoryTypeConflictException(){ }

    /**
     * A descriptive constructor for <tt>MemoryTypeConflictException</tt>
     * @param description Description of the exception
     */
    public MemoryTypeConflictException(String description){
        super(description);
    }
    
}
