package javax.realtime;

/**
 * Thrown if the constructor of an {@link ImmortalPhysicalMemory},
 * {@link LTPhysicalMemory}, {@link VTPhysicalMemory}, {@link RawMemoryAccess},
 *  or {@link RawMemoryFloatAccess} is given an invalid size or if an 
 * accessor method on one of the above classes would cause access to 
 * an invalid address.
 *
 * @since 1.0.1 Becomes unchecked
 *
 * @spec RTSJ 1.0.1
 */
public class SizeOutOfBoundsException extends RuntimeException {

    /**
     * A constructor for <tt>SizeOutOfBoundsException</tt>.
     */
    public SizeOutOfBoundsException() { }

    /**
     * A descriptive constructor for <tt>SizeOutOfBoundsException</tt>.
     *
     * @param description The description of the exception.
     */
    public SizeOutOfBoundsException(String description)  {
        super(description);
    }
}
