package javax.realtime;

/**
 * This exception is used to indicate a situation where an instance of 
 * {@link AsyncEvent} attempts to bind to a happening that does not exist.
 *
 * @spec RTSJ 1.0.1
 */
public class UnknownHappeningException extends RuntimeException {

    /**
     * A constructor for <tt>UnknownHappeningException</tt>.
     */
    public UnknownHappeningException() { }

    /**
     * A descriptive constructor for <tt>UnknownHappeningException</tt>
     * @param description Description of the exception.
     */
    public UnknownHappeningException(String description) {
        super(description);
    }
}
